/* begincopyright
  Copyright (c) 1988 Xerox Corporation. All rights reserved.
  Use and copying of this software and preparation of derivative works based
  upon this software are permitted. Any distribution of this software or
  derivative works must comply with all applicable United States export
  control laws. This software is made available AS IS, and Xerox Corporation
  makes no warranty about the software, its performance or its conformity to
  any specification. Any person obtaining a copy of this software is requested
  to send their name and post office or electronic mail address to
  PCRCoordinator.pa@xerox.com, or to:
    PCR Coordinator
    Xerox PARC
    3333 Coyote Hill Rd.
    Palo Alto, CA 94304
  endcopyright */

/*
 * CommandLinePrivate.h
 *
 * PCR command line interface private defs.
 *
 * Demers, April 10, 1990 2:24:11 pm PDT
 */


#ifndef _XR_COMMAND_LINE_PRIVATE_
#define _XR_COMMAND_LINE_PRIVATE_ 1

#ifndef _XR_COMMAND_LINE_
#   include "xr/CommandLine.h"
#endif

#ifndef _XR_THREADS_
#   include "xr/Threads.h"
#endif



typedef struct XR_CLHandleRep {
    /* lock */
        struct XR_MLRep clh_ml;
    /* parameters */
        int clh_nestLevel;
        bool clh_minusIsDelim;
    /* strings buffer */
        int clh_argc;
        int clh_argcLim;
        char **clh_argv;
    /* input proc */
        XR_MesaProc clh_charProc;
        int clh_peekc;
    /* prompt proc (interactive use) */
        XR_MesaProc clh_promptProc;
} *XR_CLHandleInner;
/*
    Handle to a command line.
*/


typedef struct XR_CLRegistrationRep {
    char *clr_key;
    bool clr_caseSensitive;
    char *clr_helpMsg;
    XR_MesaProc clr_proc;
    struct XR_CLRegistrationRep *clr_next;
} *XR_CLRegistrationInner;
/*
    Handle to a registered CLProc.
*/


typedef struct XR_CLProcsHandleRep {
    XR_CLRegistrationInner clph_registrations;
} * XR_CLProcsHandleInner;
/*
    Handle to collection of registered CLProcs.
*/



#endif
